> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Rotate Secret

> Complete the rotation of an M2M client secret

Complete the rotation of an M2M client secret started with the [Start Secret Rotation Endpoint](/api-reference/b2b/api/m2m/rotate-secret/start-secret-rotation). After this endpoint is called, the client's `next_client_secret` becomes its `client_secret` and the previous `client_secret` will no longer be valid.


## OpenAPI

````yaml POST /v1/m2m/clients/{client_id}/secrets/rotate
openapi: 3.0.3
info:
  title: Stytch API
  description: The Stytch API provides endpoints for authentication and user management.
  version: 2.1.1
  contact:
    name: Stytch Support
    url: https://stytch.com/docs
    email: support@stytch.com
servers:
  - url: https://api.stytch.com
    description: Production server
  - url: https://test.stytch.com
    description: Test server
security:
  - basicAuth: []
paths:
  /v1/m2m/clients/{client_id}/secrets/rotate:
    post:
      tags:
        - Clients
      summary: Rotate
      description: >-
        Complete the rotation of an M2M client secret started with the [Start
        Secret Rotation
        Endpoint](https://stytch.com/docs/b2b/api/m2m-rotate-secret-start)
        [Start Secret Rotation
        Endpoint](https://stytch.com/docs/api/m2m-rotate-secret-start).

        After this endpoint is called, the client's `next_client_secret` becomes
        its `client_secret` and the previous `client_secret` will no longer be
        valid.
      operationId: api_m2m_v1_m2m_clients_secrets_Rotate
      parameters:
        - name: client_id
          in: path
          required: true
          schema:
            type: string
            description: The ID of the client.
          description: The ID of the client.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/api_m2m_v1_m2m_clients_secrets_RotateRequest
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api_m2m_v1_m2m_clients_secrets_RotateResponse
        '400':
          description: Bad request
        '401':
          description: Unauthorized
          content:
            application/json:
              example:
                status_code: 401
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: unauthorized_credentials
                error_message: Unauthorized credentials.
                error_url: https://stytch.com/docs/api/errors/401
        '429':
          description: Too Many Requests
          content:
            application/json:
              example:
                status_code: 429
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: too_many_requests
                error_message: Too many requests have been made.
                error_url: https://stytch.com/docs/api/errors/429
        '500':
          description: Internal server error
          content:
            application/json:
              example:
                status_code: 500
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: internal_server_error
                error_message: >-
                  Oops, something seems to have gone wrong, please reach out to
                  support@stytch.com to let us know what went wrong.
                error_url: https://stytch.com/docs/api/errors/500
      x-code-samples:
        - lang: csharp
          label: C#
          source: |-
            // POST /v1/m2m/clients/{client_id}/secrets/rotate
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              client_id: "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
            };

            client.M2M.Clients.Secrets.Rotate(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: go
          label: Go
          source: "// POST /v1/m2m/clients/{client_id}/secrets/rotate\npackage main\n\nimport (\n\t\"context\"\n\t\"log\"\n\n\t\"github.com/stytchauth/stytch-go/v18/stytch/b2b/b2bstytchapi\"\n\t\"github.com/stytchauth/stytch-go/v18/stytch/consumer/m2m/clients/secrets\"\n)\n\nfunc main() {\n\tclient, err := b2bstytchapi.NewClient(\n\t\t\"${projectId}\",\n\t\t\"${secret}\",\n\t)\n\tif err != nil {\n\t\tlog.Fatalf(\"error instantiating client: %v\", err)\n\t}\n\n\tparams := &secrets.RotateParams{\n\t\tClientID: \"m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885\",\n\t}\n\n\tresp, err := client.M2M.Clients.Secrets.Rotate(context.Background(), params)\n\tif err != nil {\n\t\tlog.Fatalf(\"error in method call: %v\", err)\n\t}\n\n\tlog.Println(resp)\n}\n"
        - lang: java
          label: Java
          source: >-
            // POST /v1/m2m/clients/{client_id}/secrets/rotate

            package com.example;


            import com.stytch.java.b2b.StytchB2BClient;

            import com.stytch.java.common.StytchResult;

            import
            com.stytch.java.consumer.models.m2mclientssecrets.RotateRequest;


            public class Main {
                public static void main(String[] args) {
                    StytchB2BClient.configure("${projectId}", "${secret}");

                    RotateRequest params = new RotateRequest();
                    params.setClientId("m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885");

                    Object result = StytchB2BClient.getM2M().getClients().getSecrets().rotate(params);
                    if (result instanceof StytchResult.Success) {
                      System.out.println(((StytchResult.Success) result).getValue());
                    } else {
                      System.out.println(((StytchResult.Error) result).getException());
                    }
                }
            }
        - lang: kotlin
          label: Kotlin
          source: >
            // POST /v1/m2m/clients/{client_id}/secrets/rotate

            package com.example


            import com.stytch.java.b2b.StytchB2BClient

            import
            com.stytch.java.consumer.models.m2mclientssecrets.RotateRequest


            fun main() {
                StytchB2BClient.configure(
                    projectId = "${projectId}",
                    secret = "${secret}",
                )

                when (
                    val result =
                        StytchB2BClient.m2m.clients.secrets.rotate(
                            RotateRequest(
                                clientId = "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
                            ),
                        )
                ) {
                    is StytchResult.Success -> println(result.value)
                    is StytchResult.Error -> println(result.exception)
                }
            }
        - lang: javascript
          label: Node.js
          source: |-
            // POST /v1/m2m/clients/{client_id}/secrets/rotate
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              client_id: "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
            };

            client.m2m.clients.secrets.rotate(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: php
          label: PHP
          source: |-
            $response = $client->m2m->clients->secrets->rotate([
                'client_id' => 'm2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885',
            ]);
        - lang: python
          label: Python
          source: |
            # POST /v1/m2m/clients/{client_id}/secrets/rotate
            from stytch import B2BClient

            client = B2BClient(
                project_id="${projectId}",
                secret="${secret}",
            )

            resp = client.m2m.clients.secrets.rotate(
                client_id="m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
            )

            print(resp)
        - lang: ruby
          label: Ruby
          source: |-
            # frozen_string_literal: true

            # POST /v1/m2m/clients/{client_id}/secrets/rotate
            require 'stytch'

            client = StytchB2B::Client.new(
              project_id: "${projectId}",
              secret: "${secret}"
            )

            resp = client.m2m.clients.secrets.rotate(
              client_id: "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885"
              
            )

            puts resp
        - lang: rust
          label: Rust
          source: |-
            // POST /v1/m2m/clients/{client_id}/secrets/rotate
            use stytch::b2b::client::Client;
            use stytch::consumer::m2m_clients_secrets::RotateRequest;

            fn main() {
                let client = Client::new("${projectId}", "${secret}").unwrap();
                let resp = client.m2m.clients.secrets.rotate(
                    RotateRequest{
                        client_id: "m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885",
                        ..Default::default()
                    }
                ).await;
                println!("The response is {:?}", resp);
            }
        - lang: bash
          label: cURL
          source: |-
            # POST /v1/m2m/clients/{client_id}/secrets/rotate
            curl --request POST \
              --url https://test.stytch.com/v1/m2m/clients/m2m-client-test-d731954d-dab3-4a2b-bdee-07f3ad1be885/secrets/rotate \
              -u '${projectId}:${secret}' \
              -H 'Content-Type: application/json'
components:
  schemas:
    api_m2m_v1_m2m_clients_secrets_RotateRequest:
      type: object
      properties: {}
      description: Request type
    api_m2m_v1_m2m_clients_secrets_RotateResponse:
      type: object
      properties:
        request_id:
          type: string
          description: >-
            Globally unique UUID that is returned with every API call. This
            value is important to log for debugging purposes; we may ask for
            this value to help identify a specific API call when helping you
            debug an issue.
        m2m_client:
          $ref: '#/components/schemas/api_m2m_v1_M2MClient'
          description: The M2M Client affected by this operation.
        status_code:
          type: integer
          format: int32
          description: >-
            The HTTP status code of the response. Stytch follows standard HTTP
            response status code patterns, e.g. 2XX values equate to success,
            3XX values are redirects, 4XX are client errors, and 5XX are server
            errors.
      required:
        - request_id
        - m2m_client
        - status_code
    api_m2m_v1_M2MClient:
      type: object
      properties:
        client_id:
          type: string
          description: The ID of the client.
        client_name:
          type: string
          description: A human-readable name for the client.
        client_description:
          type: string
          description: A human-readable description for the client.
        status:
          type: string
          description: The status of the client - either `active` or `inactive`.
        scopes:
          type: array
          items:
            type: string
          description: An array of scopes assigned to the client.
        client_secret_last_four:
          type: string
          description: The last four characters of the client secret.
        trusted_metadata:
          type: object
          additionalProperties: true
          description: An arbitrary JSON object for storing application-specific data.
        next_client_secret_last_four:
          type: string
          description: >-
            The last four characters of the `next_client_secret`. Null if no
            `next_client_secret` exists.
      required:
        - client_id
        - client_name
        - client_description
        - status
        - scopes
        - client_secret_last_four
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````